wok annotate syslinux/stuff/iso2exe/init @ rev 21553

syslinux/iso2exe,taziso: add slitaz.pif
author Pascal Bellard <pascal.bellard@slitaz.org>
date Fri May 10 19:27:17 2019 +0200 (6 months ago)
parents daaaf5face8a
children 04ffefac5707
rev   line source
pascal@21302 1 #!/bin/sh
pascal@13691 2
pascal@13691 3 DIALOG=dialog
pascal@13691 4
pascal@17454 5 ddq()
pascal@17454 6 {
pascal@17454 7 dd $@ 2> /dev/null
pascal@17454 8 }
pascal@17454 9
pascal@13691 10 get()
pascal@13691 11 {
pascal@17496 12 od -v -j $1 -N ${4:-${3:-2}} -t u${3:-2} -w${3:-2} -An $2 2>/dev/null ||
pascal@21460 13 hexdump -v -s $1 -n ${4:-${3:-2}} -e "\"\" 1/${3:-2} \" %u\n\"" $2
pascal@13691 14 }
pascal@13691 15
pascal@13691 16 getarg()
pascal@13691 17 {
pascal@13691 18 sed "/$1=/!d;s/.*$1=\\([^ ]*\\).*/\\1/" /proc/cmdline
pascal@13691 19 }
pascal@13691 20
pascal@17489 21 clear()
pascal@17489 22 {
pascal@17489 23 echo -e "\x1B[1;1H\x1B[J"
pascal@17489 24 }
pascal@17489 25
pascal@17569 26 xless()
pascal@17569 27 {
pascal@17569 28 [ $(wc -l < "$1") -gt 22 ] &&
pascal@17569 29 sed 's/..3.;4.m/===/g;$s/.*/&\n---\nPress q to continue/' "$1" | less ||
pascal@17569 30 { cat "$1"
pascal@17569 31 [ "$2" ] || return
pascal@17569 32 echo -e "$2"
pascal@17569 33 read n
pascal@17569 34 }
pascal@17569 35 }
pascal@17569 36
pascal@17489 37 tinydialog()
pascal@17489 38 {
pascal@17489 39 clear
pascal@17489 40 label=""
pascal@17489 41 while [ "$1" ]; do
pascal@17489 42 case "$1" in
pascal@17489 43 --title) title=" \x1B[30;47m$2\x1B[37;40m\n"
pascal@17489 44 echo -e $title; shift ;;
pascal@17489 45 --yes-label) label="$2" ; shift ;;
pascal@17489 46 --textbox)
pascal@17569 47 xless "$2" "\nPress RETURN to continue."
pascal@17489 48 break;;
pascal@17489 49 --gauge)
pascal@17489 50 t=" "
pascal@17489 51 echo -e "$t$2\n"
pascal@17489 52 while read pct ; do
pascal@17489 53 s=" "
pascal@17489 54 s="$s$pct%$s"
pascal@17489 55 pct=$((($pct*63)/100))
pascal@17489 56 echo -en "\r$t\x1B[30;47m$(echo "$s" | cut -c-$pct)\x1B[37;40m$(echo "$s" | cut -c$(($pct+1))-)"
pascal@17489 57 done
pascal@17489 58 break;;
pascal@17489 59 --yesno)
pascal@17489 60 while true; do
pascal@17489 61 clear
pascal@17491 62 echo "$2" | sed 's/\\n\\n/\\n/g;s/\\n/\n/g'
pascal@17491 63 echo -en " <- 1:${label:-Yes} 2:Cancel\r"
pascal@17489 64 read x
pascal@17489 65 case "$x" in
pascal@17489 66 ''|Y*|y*|1) return 0;;
pascal@17489 67 N*|n*|2|0) return 1;;
pascal@17489 68 esac
pascal@17489 69 done ;;
pascal@17489 70 --menu|--radiolist)
pascal@20891 71 [ "$1" = "--menu" ] && shft=2 || shft=3
pascal@17491 72 label=""
pascal@20771 73 [ "$2" ] && label="\n$2"
pascal@17489 74 shift 5
pascal@17491 75 echo -e "$title$label\n0 Cancel" > /tmp/data
pascal@17489 76 n=1
pascal@17489 77 while [ "$1" ]; do
pascal@17489 78 eval key_$n='$1'
pascal@17489 79 echo "$((n++)) $2"
pascal@17491 80 shift $shft
pascal@17489 81 done >> /tmp/data
pascal@17489 82 while ! grep -q "^$n " /tmp/data ; do
pascal@17489 83 clear
pascal@17569 84 xless /tmp/data
pascal@17489 85 echo -en "\n <- Enter the selection number\r"
pascal@17489 86 read n
pascal@17489 87 done 2> /dev/null
pascal@17489 88 rm -f /tmp/data
pascal@17489 89 [ $n -eq 0 ] && return 1
pascal@17489 90 eval echo -n \$key_$n 1>&2
pascal@17489 91 return 0;;
pascal@17489 92 esac
pascal@17489 93 shift
pascal@17489 94 done
pascal@17489 95 }
pascal@17489 96
pascal@16041 97 mount_proc()
pascal@16041 98 {
pascal@16041 99 mount -t proc /proc /proc
pascal@16041 100 mount -t sysfs /sys /sys
pascal@16041 101 udevd --daemon 2> /dev/null && udevadm trigger && sleep 5
pascal@16041 102 }
pascal@16041 103
pascal@16041 104 umount_proc()
pascal@16041 105 {
pascal@16041 106 killall udevd 2> /dev/null
pascal@16041 107 umount /sys/fs/fuse/connections 2> /dev/null
pascal@16041 108 umount /sys
pascal@16041 109 umount /proc
pascal@16041 110 }
pascal@16041 111
pascal@17473 112 bytes2bin()
pascal@17473 113 {
pascal@17473 114 for i in $@ ; do
pascal@17569 115 printf '\\\\x%02X' $(($i&255))
pascal@17569 116 done | xargs echo -en
pascal@17473 117 }
pascal@17473 118
pascal@17454 119 words2bin()
pascal@17454 120 {
pascal@17454 121 for i in $@ ; do
pascal@17569 122 printf '\\\\x%02X\\\\x%02X' $(($i&255)) $((($i>>8)&255))
pascal@17569 123 done | xargs echo -en
pascal@17454 124 }
pascal@17454 125
pascal@13691 126 gettazboot()
pascal@13691 127 {
pascal@21506 128 echo -e "\nCreating $(basename $1) ..."
pascal@21472 129 X=$(($(get 20 /mnt/$ISO) - 0xC0))
pascal@21472 130 [ $X -lt 30000 ] && X=$((0x7FF0))
pascal@17810 131 O=$(($(get 64 /mnt/$ISO) - 0xC0))
pascal@21472 132 L=$(($X - $(get 24 /mnt/$ISO) - $O))
pascal@13691 133 S=$((32+$L))
pascal@13691 134 P=$((($S+511)/512))
pascal@13691 135 E=$((4096-(32*$P)))
pascal@17454 136 words2bin 0x5A4D $(($S%512)) $P 0 2 $E -1 $((${2:-0}-16)) \
pascal@17454 137 -2 0 256 -16 28 0x6C53 0x5469 0x7A61 > $1
pascal@21472 138 ddq bs=1 count=$(echo $L) skip=$(echo $O) if=/mnt/$ISO >> $1
pascal@13691 139 }
pascal@13691 140
pascal@13691 141 checkmagic()
pascal@13691 142 {
pascal@20891 143 [ -s $1 ] && [ $(getarg magic) = $(get 18 $1 2) ]
pascal@13691 144 }
pascal@13691 145
pascal@13691 146 getiso()
pascal@13691 147 {
pascal@13713 148 mkdir -p /media/cdrom
pascal@17489 149 for dev in /sys/block/?d?/?d??* ; do
pascal@17489 150 mount /dev/$(basename $dev) /mnt
pascal@13713 151 if checkmagic /mnt/$ISO; then
pascal@13713 152 mount -o loop,ro /mnt/$ISO /media/cdrom
pascal@17489 153 echo "Found $ISO on $(basename $dev)"
pascal@19510 154 return 0
pascal@13713 155 fi
pascal@13713 156 umount /mnt
pascal@19510 157 done 2> /dev/null
pascal@19510 158 return 1
pascal@13691 159 }
pascal@13691 160
pascal@13691 161 uncpio()
pascal@13691 162 {
pascal@17489 163 [ -s "$1" ] || return
pascal@17476 164 echo -en "\n Extracting $(basename $1) ..."
pascal@13699 165 case $(get 0 $1) in
pascal@17160 166 *35615) ( zcat || gunzip ) ;;
pascal@17476 167 *14333) unxz ;;
pascal@17160 168 *\ 93) unlzma ;;
pascal@17160 169 *) cat ;;
pascal@17160 170 esac < $1 | ( cd ${2:-/} ; cpio -idmu > /dev/null 2>&1 )
pascal@13691 171 }
pascal@13691 172
pascal@17476 173 dotwait()
pascal@17476 174 {
pascal@17476 175 echo -n "${1:-Install filesystem}.."
pascal@21363 176 echo -n > /tmp/wait
pascal@17476 177 while [ -e /tmp/wait ]; do
pascal@17476 178 echo -n "." > /dev/tty0
pascal@17476 179 sleep 1
pascal@17476 180 done &
pascal@17476 181 }
pascal@17476 182
pascal@13691 183 getuuid()
pascal@13691 184 {
pascal@13691 185 dev=$(mount | sed '/ \/mnt /!d;s/ .*//;s|/dev/||;q')
pascal@16041 186 blkid | sed "/$dev:/!d;s/.* UUID=.\\([^ ]*\\)\".*/\\1/"
pascal@13691 187 }
pascal@13691 188
pascal@16055 189 tazusbinitfs()
pascal@16055 190 {
pascal@16055 191 PAD=$(($(stat -c %s $1) % 4))
pascal@17454 192 [ $PAD -ne 0 ] && ddq if=/dev/zero bs=1 count=$((4 - $PAD)) >> $1
pascal@16055 193 mkdir -p /tmp/fs/etc /tmp/fs/lib /tmp/fs/home
pascal@21519 194 cp /etc/keymap.conf /etc/locale.conf /tmp/fs/etc 2> /dev/null
pascal@16055 195 cat > /tmp/fs/init1 <<EOT
pascal@16055 196 #!/bin/sh
pascal@16055 197 sed -i 's|sbin/init|init2|' /init
pascal@16055 198 exec /init
pascal@16055 199 EOT
pascal@16055 200 cat > /tmp/fs/init2 <<EOT
pascal@16055 201 #!/bin/sh
pascal@16055 202
pascal@16055 203 mount -t proc /proc /proc
pascal@21519 204 for i in /lib/modules/*.ko* ; do insmod \$i 2> /dev/null ; done; sleep 2
pascal@16055 205 v=\$(sed '/\\/home=/!d;s|.*/home=\\([^ ]*\\).*|\\1|' /proc/cmdline /cmdline 2> /dev/null)
pascal@16055 206 mount / -o remount,rw
pascal@16055 207 mkdir /mnt/dos
pascal@16055 208 rm -f /cmdline 2> /dev/null
pascal@16055 209 mount / -o remount,ro
pascal@16055 210 mnt=/mnt/dos/\${v#*/}
pascal@16055 211 dev=\$( (blkid /dev/[sh]d* || blkid) | grep \${v%%/*} | sed 's/:.*//;q')
pascal@16055 212 echo "Mount \$dev in /mnt/dos for \$v..." | tee -a /run/boot.log
pascal@16055 213 mount \$dev /mnt/dos
pascal@16055 214 mount.posixovl -F \$mnt -- -oallow_other -odefault_permissions -osuid
pascal@16055 215 mount --bind \$mnt /home
pascal@21506 216 mount -o size=0,ro -t tmpfs tmpfs \$mnt
pascal@16055 217 umount /proc
pascal@16055 218 exec /sbin/init
pascal@16055 219 EOT
pascal@16055 220 chmod 755 /tmp/fs/init?
pascal@16055 221 cp -a /tmp/fs/* /
pascal@21519 222 ln -s /sqfs/bin/gzip /bin 2> /dev/null
pascal@16055 223 ( cd /tmp/fs ; find * | cpio -o -H newc ) | gzip -9 >> $1
pascal@16055 224 }
pascal@16055 225
pascal@13691 226 mkinitrd()
pascal@13691 227 {
pascal@21472 228 echo
pascal@17476 229 dotwait "Creating $(basename $1) "
pascal@13691 230 for i in bin lib dev proc tmp mnt etc ; do
pascal@13691 231 mkdir -p /tmp/fs/$i
pascal@13691 232 done
pascal@21506 233 for i in /dev/console /dev/null /dev/tty /dev/tty[012] /dev/fuse /dev/[hs]d* ; do
pascal@13691 234 cp -a $i /tmp/fs$i
pascal@13691 235 done
pascal@13713 236 for i in /bin/busybox $(which mount.posixovl) $(which blkid); do
pascal@13691 237 cp $(LD_TRACE_LOADED_OBJECTS=1 /lib/ld*.so $i | \
pascal@13691 238 sed 's|.*=> \(.*/lib/l[^ ]*\).*|\1|;/^\//!d') /tmp/fs/lib
pascal@13691 239 cp $i /tmp/fs/bin
pascal@13691 240 done
pascal@21519 241 cp -a /sqfs/lib/ld-* /tmp/fs/lib 2> /dev/null ||
pascal@13691 242 cp -a /lib/ld-* /tmp/fs/lib
pascal@13691 243 for i in $(busybox | sed '/Current/,$!d'); do
pascal@14271 244 [ -e /tmp/fs/bin/${i%,} ] || ln -s busybox /tmp/fs/bin/${i%,}
pascal@13691 245 done
pascal@13691 246 ln -s /proc/mounts /tmp/fs/etc/mtab
pascal@16041 247 sed 's/ .*//' /proc/modules | while read mod ; do
pascal@16041 248 find /lib/modules/ | grep $mod.ko | \
pascal@16041 249 sed 's|.*|cp & /tmp/fs/lib|' | sh
pascal@16041 250 done
pascal@13691 251 cat > /tmp/fs/init <<EOT
pascal@13691 252 #!/bin/sh
pascal@13691 253
pascal@13691 254 arg()
pascal@13691 255 {
pascal@13691 256 grep -q \$1 /proc/cmdline &&
pascal@13691 257 val="\$(sed "s/.*\$1=\\([^ ]*\\).*/\\1/" < /proc/cmdline)" &&
pascal@13691 258 echo "\$2 \$val"
pascal@13691 259 }
pascal@13691 260
pascal@13691 261 mount -t proc /proc /proc
pascal@16055 262 for i in /lib/*.ko* ; do insmod \$i 2> /dev/null ; done; sleep 2
pascal@13691 263 arg mount "Mount device"
pascal@16055 264 mount \$( (blkid /dev/[sh]d* || blkid) | grep \$val | sed 's/:.*//;q') /mnt
pascal@13691 265 arg subroot "Change root to directory"
pascal@16041 266 mount.posixovl -F /mnt/\$val -- -oallow_other -odefault_permissions -osuid
pascal@13691 267 mount --bind /mnt /mnt/\$val/mnt/dos
pascal@21472 268 mount -o size=0,ro -t tmpfs tmpfs /mnt/\$val/mnt/dos/\$val
pascal@13691 269 LDSO=\$(ls /mnt/\$val/lib/ld-* | sed q)
pascal@16041 270 export LD_LIBRARY_PATH=\$val/lib:\$val/usr/lib:/lib
pascal@13691 271 umount /proc
pascal@13691 272 exec /bin/switch_root /mnt \${LDSO#/mnt/} \$val/usr/sbin/chroot \$val /sbin/init
pascal@13691 273 EOT
pascal@13691 274 chmod +x /tmp/fs/init
pascal@13691 275 ( cd /tmp/fs ; find * | cpio -o -H newc ) | lzma e $1 -si 2> /dev/null
pascal@17476 276 rm -rf /tmp/fs /tmp/wait
pascal@13691 277 }
pascal@13691 278
pascal@13713 279 is_loram()
pascal@13713 280 {
pascal@21459 281 [ -s /lib/modules/squashfs.ko* ]
pascal@13713 282 }
pascal@13713 283
pascal@16041 284 ls_r()
pascal@16041 285 {
pascal@16041 286 ls -r $@ 2> /dev/null || ls $@
pascal@16041 287 }
pascal@16041 288
pascal@13691 289 doinstall()
pascal@13691 290 {
pascal@14271 291 mkdir -p /mnt/slitaz/boot /mnt/slitaz/mnt/dos
pascal@16041 292 if ! mount.posixovl -F /mnt/slitaz -- \
pascal@16041 293 -oallow_other -odefault_permissions -osuid; then
pascal@16041 294 echo "Can't install SliTaz. Abort."
pascal@16041 295 sleep 5
pascal@16041 296 return 1
pascal@16041 297 fi
pascal@17635 298 dotwait "Install root filesystem in /slitaz.."
pascal@17454 299 if [ "$1" ]; then
pascal@14271 300 if [ -d /media/cdrom/fs ]; then
pascal@14271 301 ( cd /mnt/slitaz/fs; find | cpio -o -H newc ) | gzip -9
pascal@14271 302 else
pascal@17635 303 ls_r /media/cdrom/boot/rootfs*gz | xargs cat
pascal@14271 304 fi > /mnt/slitaz/boot/rootfs.gz
pascal@16055 305 tazusbinitfs /mnt/slitaz/boot/rootfs.gz
pascal@14271 306 initrd=rootfs.gz
pascal@16055 307 extraargs="/home=$(getuuid)/slitaz rdinit=/init1"
pascal@13713 308 else
pascal@14271 309 if [ -d /media/cdrom/fs ]; then
pascal@14271 310 cp -a /media/cdrom/fs/. /mnt/slitaz
pascal@14271 311 elif is_loram ; then
pascal@17635 312 for i in $(ls_r /media/cdrom/boot/rootfs*gz); do
pascal@21506 313 losetup -o 124 /dev/loop7 $i
pascal@21506 314 mount -t squashfs -o ro /dev/loop7 /sqfs/mnt
pascal@14271 315 cp -a /sqfs/mnt/. /mnt/slitaz
pascal@21506 316 umount /sqfs/mnt
pascal@21506 317 losetup -d /dev/loop7
pascal@14271 318 done
pascal@14271 319 else
pascal@17635 320 for i in $(ls_r /media/cdrom/boot/rootfs*gz); do
pascal@14271 321 uncpio $i /mnt/slitaz
pascal@14271 322 done
pascal@14271 323 fi
pascal@14271 324 mkinitrd /mnt/slitaz/boot/initrd
pascal@14271 325 initrd=initrd
pascal@14271 326 extraargs="mount=$(getuuid) subroot=slitaz"
pascal@13713 327 fi
pascal@17476 328 echo -en "\nInstall boot files..."
pascal@13691 329 for i in /media/cdrom/boot/bzImage /media/cdrom/boot/*pxe* \
pascal@13691 330 /media/cdrom/boot/isolinux/he* /media/cdrom/boot/isolinux/opt* \
pascal@13691 331 /media/cdrom/README /media/cdrom/boot/memtest* ; do
pascal@13691 332 [ -s $i ] && cp $i /mnt/slitaz/boot
pascal@13691 333 done
pascal@21472 334 for i in /mnt/slitaz/boot/memtest /mnt/slitaz/boot/*pxe ; do
pascal@16047 335 [ $(get 0 $i 2> /dev/null || echo 0) -eq 23117 ] &&
pascal@16047 336 mv $i $i.exe
pascal@16047 337 done
pascal@21506 338 cp /etc/keymap.conf /etc/locale.conf /mnt/slitaz/etc 2> /dev/null
pascal@13691 339 gettazboot /mnt/slitaz/boot/tazboot.exe
pascal@14247 340 unix2dos > /mnt/slitaz/boot/tazboot.cmd <<EOT
pascal@16041 341 kernel=/slitaz/boot/bzimage
pascal@16041 342 initrd=/slitaz/boot/$initrd
pascal@14271 343 rw root=/dev/null $extraargs autologin
pascal@13691 344 EOT
pascal@21553 345 uudecode - <<EOT | gunzip > /mnt/slitaz/boot/slitaz.pif
pascal@21553 346 begin-base64 644 -
pascal@21553 347 H4sIAAAAAAACA8XPxUHGMBTA8X9ecb/glgFwv+FO23zeI+7ucMFhCjZgEEZh
pascal@21553 348 Ctzd4Rf3PFbtQHGLG9BmfmZqdlE/tSmw2LfePzOzWDK0OsQXpPHvFGfZBmL5
pascal@21553 349 f3Zns98NuG1BbTrbWj0OFMypSKfT4kYCurKuRleWlBEth2qUTYFBKjg746pI
pascal@21553 350 2nZaIT/v9vWwbeuqi9fPznLlSPFLLuK22/0lLT09/BDhXgWKO1f9aLKxOObE
pascal@21553 351 EhLuVvO4FksSwaH5qbHpvkle0TyzND82NK+doRVeZgGGbIw0XD2QwV9SnAN/
pascal@21553 352 ACxDxwMAAA==
pascal@21553 353 ====
pascal@21553 354 EOT
pascal@13691 355 unix2dos /mnt/slitaz/boot/he* /mnt/slitaz/boot/opt* \
pascal@14247 356 /mnt/slitaz/boot/README
pascal@14271 357 [ -d /mnt/slitaz/usr/sbin -a ! -x /mnt/slitaz/usr/sbin/mount.posixovl ] &&
pascal@13713 358 cp $(which mount.posixovl) /mnt/slitaz/usr/sbin
pascal@17476 359 rm -f /tmp/wait
pascal@16041 360 false &&
pascal@17476 361 [ -s /mnt/boot.ini ] && ! grep -qs tazboot /mnt/boot.ini &&
pascal@17476 362 echo "Update boot.ini ..." && unix2dos >> /mnt/boot.ini <<EOT
pascal@13691 363 C:\\slitaz\\boot\\tazboot.exe="SliTaz"
pascal@13691 364 EOT
pascal@16073 365 false &&
pascal@16073 366 grep -qis menuitem /mnt/config.sys && ! grep -qi tazboot /mnt/config.sys &&
pascal@16041 367 echo "Update config.sys ..." &&
pascal@16073 368 sed -i 's/menudefault/menuitem SLITAZ, SliTaz\r\n&/' /mnt/config.sys &&
pascal@16073 369 unix2dos >> /mnt/config.sys <<EOT
pascal@16073 370 [SLITAZ]
pascal@16073 371 install=\\slitaz\\boot\\tazboot.exe
pascal@13691 372 EOT
pascal@16041 373 return 0
pascal@13691 374 }
pascal@13691 375
pascal@13691 376 install()
pascal@13691 377 {
pascal@20771 378 $DIALOG --clear --title " SliTaz UMSDOS way installation " \
pascal@13691 379 --yes-label "Install" --yesno \
pascal@13691 380 "\nSliTaz will be installed in the subdirectory \\slitaz of the current
pascal@13691 381 DOS/Windows partition. You will see your files from /mnt/dos.\n\n
paul@13692 382 You can start SliTaz with \\slitaz\\boot\\tazboot.exe\n\n
pascal@13691 383 To uninstall SliTaz, you have only to remove this directory.
pascal@13691 384 The file \\boot.ini or \\config.sys may be modified too.\n\n
pascal@20771 385 SliTaz may run slowly on the 'UMSDOS way' installation due to the
paul@14320 386 posixovl filesystem. The 'TAZUSB way' installation runs faster.\n\n
pascal@13697 387 To do a traditional installation with disk partitioning,
pascal@20771 388 start SliTaz Live with the 'SliTaz RAM boot' menu.\n" 19 70
pascal@14271 389 [ $? -eq 0 ] || return
pascal@16041 390 doinstall || return
pascal@16041 391 [ -x /mnt/slitaz/sbin/init ] || return
pascal@14271 392 umount -d /media/cdrom
pascal@16041 393 umount_proc
pascal@13691 394 exec chroot /mnt/slitaz /sbin/init
pascal@13691 395 }
pascal@13691 396
pascal@14271 397 installtaz()
pascal@14271 398 {
pascal@20771 399 $DIALOG --clear --title " SliTaz TAZUSB way installation " \
pascal@14271 400 --yes-label "Install" --yesno \
pascal@14271 401 "\nSliTaz will be installed in the subdirectory \\slitaz of the current
pascal@14271 402 DOS/Windows partition. You will see your files from /mnt/dos.\n\n
pascal@14271 403 You can start SliTaz with \\slitaz\\boot\\tazboot.exe\n\n
pascal@14271 404 To uninstall SliTaz, you have only to remove this directory.
pascal@14271 405 The file \\boot.ini or \\config.sys may be modified too.\n\n
pascal@14271 406 The filesystem is loaded entirely into memory upon boot to
paul@19451 407 increase responsiveness. Only /home lands on the hard disk.\n\n
pascal@14271 408 To do a traditional installation with disk partitioning,
pascal@20771 409 start SliTaz Live with the 'SliTaz RAM boot' menu.\n" 19 70
pascal@14271 410 [ $? -eq 0 ] || return
pascal@16041 411 doinstall tazusblike || return
pascal@20771 412 dotwait
pascal@14271 413 if [ -d /media/cdrom/fs ]; then
pascal@16055 414 cp -a /media/cdrom/fs/. /
pascal@14271 415 else
pascal@17635 416 for i in $(ls_r /media/cdrom/boot/rootfs*gz); do
pascal@17454 417 uncpio $i
pascal@14271 418 done
pascal@14271 419 fi
pascal@21519 420 cp /tmp/fs/etc/* /etc 2> /dev/null
pascal@16055 421 echo "/home=$(getuuid)/slitaz" > /cmdline
pascal@17476 422 rm -f /tmp/wait
pascal@16055 423 [ -x /init1 ] || return
pascal@14271 424 umount -d /media/cdrom
pascal@16055 425 umount /mnt/slitaz
pascal@16073 426 rm -f /dev/cdrom
pascal@16055 427 umount /mnt
pascal@16055 428 mkdir /mnt/dos
pascal@16041 429 umount_proc
pascal@16055 430 exec /init1
pascal@14271 431 }
pascal@14271 432
pascal@13691 433 tazboot()
pascal@13691 434 {
pascal@20771 435 $DIALOG --clear --title " SliTaz bootloader for DOS " \
pascal@13691 436 --yes-label "Install" --yesno \
paul@13692 437 "\nThe file TAZBOOT.EXE will be created in the top directory. It supports
pascal@17476 438 any linux kernel, multiple initramfs, a kernel command line and
paul@13692 439 an ISO image file loopback (retrieves files from an ISO file).\n\n
pascal@20771 440 Usage: tazboot.exe [[@commands]|[kernel=<bzimage>]
pascal@17489 441 [initrd=<rootfs>[,<rootfs2>...]] [bootfrom=<isofile>] cmdline args ...]\n\n
paul@13692 442 Defaults: tazboot @tazboot.cmd or tazboot kernel=bzImage auto\n\n\
pascal@13691 443 Examples for tazboot.cmd:\n\n\
pascal@17489 444 bootfrom=\\isos\\slitaz-4.0.iso\n\
pascal@13691 445 kernel=boot/bzImage\n\
pascal@13691 446 initrd=boot/rootfs4.gz,boot/rootfs3.gz,boot/rootfs2.gz,boot/rootfs1.gz\n\
pascal@13691 447 rw root=/dev/null autologin\n\n\
pascal@13691 448 kernel=\\slitaz\\vmlinuz root=/dev/sda5 ro\n\n
pascal@20771 449 Unlike GRUB4DOS, it doesn't require unfragmented ISO image files.\n" 24 78
pascal@13691 450 [ $? -eq 0 ] || return
pascal@13691 451 gettazboot /mnt/tazboot.exe
pascal@13691 452 }
pascal@13691 453
pascal@13697 454 md5()
pascal@13697 455 {
pascal@17476 456 dotwait "Checking files"
pascal@18061 457 ( cd /media/cdrom ; ${1:-md5sum -c md5sum*} | sort ) > /tmp/data
pascal@17476 458 rm -f /tmp/wait
pascal@20771 459 $DIALOG --clear --title " Checked files " --textbox /tmp/data 24 78
pascal@13697 460 rm -f /tmp/data
pascal@13697 461 }
pascal@13697 462
pascal@17491 463 gotcdfile()
pascal@17491 464 {
pascal@17635 465 for i in "/media/cdrom/$1" "/media/cdrom/*/$1" \
pascal@17635 466 "/media/cdrom/*/isolinux/$1" ; do
pascal@17491 467 file=$(ls $i 2> /dev/null | sed q)
pascal@17491 468 [ -s "$file" ] && break
pascal@17491 469 done
pascal@17491 470 }
pascal@17491 471
pascal@17489 472 sha()
pascal@17489 473 {
pascal@17635 474 gotcdfile "sha*sum*"
pascal@17489 475 sha=$(basename $file)
pascal@17489 476 md5 "${sha%sum*}sum -c ${file#/media/cdrom/}"
pascal@17489 477 }
pascal@17489 478
pascal@13697 479 readme()
pascal@13697 480 {
pascal@17635 481 gotcdfile "README*"
pascal@20771 482 $DIALOG --clear --title " Readme " --textbox $file 24 78
pascal@13697 483 }
pascal@13697 484
pascal@13697 485 bootlog()
pascal@13697 486 {
pascal@20771 487 $DIALOG --clear --title " Linux boot messages " \
pascal@13697 488 --textbox /tmp/dmesg 24 78
pascal@13697 489 }
pascal@13697 490
pascal@17476 491 bzimage()
pascal@17476 492 {
pascal@20771 493 $DIALOG --clear --title " Create linux.exe ? " \
pascal@17476 494 --yes-label "Install" --yesno \
pascal@17476 495 "\nLinux.exe launches the linux kernel under DOS (in real mode only).
pascal@17569 496 The cmdline arguments are supported except initrd=,
pascal@17569 497 vga= (you can try 'rdev -v') and mem= (partially).
pascal@17569 498 \nExample:\nC:\\> linux.exe root=/dev/hda2 ro panic=60\n
pascal@17476 499 " 12 70
pascal@17476 500 [ $? -eq 0 ] || return
pascal@17476 501 cp /media/cdrom/boot/bzImage /mnt/linux.exe
pascal@17476 502 }
pascal@17476 503
pascal@13697 504 memtest()
pascal@13697 505 {
pascal@20771 506 $DIALOG --clear --title " Create memtest.exe ? " \
pascal@13697 507 --yes-label "Install" --yesno \
pascal@13697 508 "\nMemtest86 is a thorough, stand alone memory test for x86 architecture
pascal@13697 509 computers. BIOS based memory tests are a quick, cursory check and often
pascal@20771 510 miss many of the failures that are detected by Memtest86.\n" 12 70
pascal@17635 511 [ $? -eq 0 ] && gotcdfile "memtest*" && cp $file /mnt/memtest.exe
pascal@13697 512 }
pascal@13697 513
pascal@17489 514 mkfat12()
pascal@17473 515 {
pascal@17473 516 [ $(($(get 0 $1) - 0x5A4D)) -eq 0 ] || return
pascal@17473 517 J=$(($(get 3 $1 1) + 0x02))
pascal@17473 518 R=$((1 + $(get 497 $1 1) + 1 + ($(get 500 $1)-1)/32))
pascal@17473 519 [ $R -lt 2500 ] || return
pascal@17476 520 [ $((($(get 500 $1)-1) & 31)) -lt 30 ] &&
pascal@17474 521 ddq if=$file bs=32 count=1 seek=$(($R*16 - 1)) of=/dev/fd0
pascal@17473 522 G="18 0 2 0 0 0 0 0"
pascal@17473 523 [ $J -gt 25 ] || G=""
pascal@17473 524 F=0
pascal@17473 525 for i in 1 2 3; do
pascal@17473 526 F=$((((2880-$R-$F-$F)*3+1023)/1024))
pascal@17473 527 done
pascal@17473 528 bytes2bin 0xEB $J 0x90 0x20 0x20 0x20 0x20 0x20 0x20 0x20 0x20 \
pascal@17473 529 0 2 2 $(($R%256)) $(($R/256)) 2 64 0 64 11 0xF0 $F 0 \
pascal@17473 530 $G | ddq bs=1 of=/dev/fd0
pascal@17473 531 ddq if=/dev/zero bs=512 count=$((4+$F+$F)) seek=$R of=/dev/fd0
pascal@17473 532 for i in $R $(($R+$F)) ; do
pascal@17473 533 bytes2bin 0xF0 0xFF 0xFF | ddq bs=512 seek=$i of=/dev/fd0
pascal@17473 534 done
pascal@17473 535 echo -n $(basename $1) | ddq bs=1 seek=3 count=8 of=/dev/fd0
pascal@17489 536 }
pascal@17489 537
pascal@17489 538 mkfloppy()
pascal@17489 539 {
pascal@21485 540 dotwait "Create a $(basename $1 .exe) boot floppy"
pascal@17489 541 ddq if=$1 of=/dev/fd0
pascal@17489 542 mkfat12 $1
pascal@17476 543 rm -f /tmp/wait
pascal@17473 544 }
pascal@17473 545
pascal@13697 546 fdmemtest()
pascal@13697 547 {
pascal@20771 548 $DIALOG --clear --title " Create a Memtest86 boot floppy " \
pascal@13697 549 --yes-label "Create floppy" --yesno \
pascal@13697 550 "\nMemtest86 is a thorough, stand alone memory test for x86 architecture
pascal@13697 551 computers. BIOS based memory tests are a quick, cursory check and often
pascal@13697 552 miss many of the failures that are detected by Memtest86.\n\n
pascal@20771 553 Please insert a blank disk in floppy drive.\n" 12 70
pascal@17635 554 [ $? -eq 0 ] && gotcdfile "memtest*" && mkfloppy $file
pascal@13697 555 }
pascal@13697 556
pascal@16013 557 pxe()
pascal@13697 558 {
pascal@20762 559 gotcdfile "?pxe*"
pascal@21485 560 $DIALOG --clear --title " Create $(basename $file .exe).exe ? " \
pascal@13697 561 --yes-label "Install" --yesno \
pascal@13697 562 "\nBoot your operating system from the internet and enjoy a full system
pascal@13697 563 working entirely in RAM with speed and stability in mind. The Linux Kernel
pascal@13697 564 and the complete SliTaz compressed root filesystem will be loaded into RAM
pascal@20771 565 from the Web using PXE and HTTP protocols.\n" 12 70
pascal@13697 566 [ $? -eq 0 ] || return
pascal@21485 567 cp $file /mnt/$(basename $file .exe).exe
pascal@13697 568 }
pascal@13697 569
pascal@16013 570 fdpxe()
pascal@13697 571 {
pascal@20771 572 $DIALOG --clear --title " Create a SliTaz Web boot floppy " \
pascal@13697 573 --yes-label "Create floppy" --yesno \
pascal@13697 574 "\nBoot your operating system from the internet and enjoy a full system
pascal@13697 575 working entirely in RAM with speed and stability in mind. The Linux Kernel
pascal@13697 576 and the complete SliTaz compressed root filesystem will be loaded into RAM
pascal@13697 577 from the Web using PXE and HTTP protocols.\n\n
pascal@20771 578 Please insert a blank disk in floppy drive.\n" 12 70
pascal@20762 579 [ $? -eq 0 ] && gotcdfile "?pxe*" && mkfloppy $file
pascal@13697 580 }
pascal@13697 581
pascal@16041 582 gotposixovl()
pascal@16041 583 {
pascal@20771 584 mount.posixovl 2>&1 | grep -qi usage &&
pascal@16041 585 echo -en "\"$1\" \"$2\""
pascal@16041 586 }
pascal@16041 587
pascal@14271 588 xfile()
pascal@14271 589 {
pascal@17454 590 [ "$(which $1)" ] && echo -en "\"$2\" \"$3\""
pascal@14271 591 }
pascal@14271 592
pascal@13697 593 cdfile()
pascal@13697 594 {
pascal@17489 595 gotcdfile "$1" && echo -en "\"$2\" \"$3\""
pascal@17476 596 }
pascal@17476 597
pascal@17659 598 isbzImage()
pascal@17659 599 {
pascal@17659 600 [ $(get 514 $file 4) -eq 1400005704 ] &&
pascal@17659 601 [ $(($(get 529 $file 1) & 1)) -eq 1 ]
pascal@17659 602 }
pascal@17659 603
pascal@17476 604 cdfilex()
pascal@17476 605 {
pascal@17659 606 gotcdfile "$1" &&
pascal@17659 607 [ "$(which kexec)" ] &&
pascal@17659 608 isbzImage &&
pascal@17659 609 echo -en "\"$2\" \"$3\""
pascal@14271 610 }
pascal@14271 611
pascal@17491 612 cdfilef()
pascal@17491 613 {
pascal@17491 614 [ -e /sys/block/fd0 ] && cdfile "$@"
pascal@17491 615 }
pascal@17491 616
pascal@16022 617 cdexe()
pascal@16022 618 {
pascal@17489 619 gotcdfile "$1" &&
pascal@17489 620 [ $(get 0 $file 2>/dev/null || echo 0) -eq 23117 ] &&
pascal@16022 621 echo -en "\"$2\" \"$3\""
pascal@16022 622 }
pascal@16022 623
pascal@14271 624 fddata()
pascal@14271 625 {
pascal@20771 626 [ -e /sys/block/fd0 ] &&
pascal@18771 627 [ $(get 26 /mnt/$ISO 1 2> /dev/null || echo 0) -ne 0 ] &&
pascal@14271 628 echo -en "\"$1\" \"$2\""
pascal@13697 629 }
pascal@13697 630
pascal@17491 631 ishybrid()
pascal@17491 632 {
pascal@19510 633 [ $(get 510 $ISO 2> /dev/null || echo 0) -eq 43605 ] || return
pascal@17491 634 C=$((2048*$(get $(((17*2048) + 71)) /mnt/$ISO 4)))
pascal@17491 635 [ $(get $C /mnt/$ISO 4) -eq 1 ] || return
pascal@17491 636 [ $(get $(($C+30)) /mnt/$ISO 4) -eq $((0x88AA55)) ] || return
pascal@17491 637 C=$((2048*$(get $(($C+40)) /mnt/$ISO 4)))
pascal@17491 638 [ $(get $(($C+64)) /mnt/$ISO 4) -eq 1886961915 ] &&
pascal@17491 639 echo -en "\"$1\" \"$2\""
pascal@17491 640 }
pascal@17491 641
pascal@18034 642 burnable()
pascal@18034 643 {
pascal@19510 644 [ "$(sed '/Can wr.*1$/!d' /proc/sys/dev/cdrom/info 2> /dev/null)" ] &&
pascal@18034 645 [ "$(which wodim)" ] && echo -en "\"$1\" \"$2\""
pascal@18034 646 }
pascal@18034 647
pascal@18034 648 blankable()
pascal@18034 649 {
pascal@19510 650 [ "$(sed '/Can wr.*RW.*1$/!d' /proc/sys/dev/cdrom/info 2> /dev/null)" ] &&
pascal@18034 651 [ "$(which wodim)" ] && echo -en "\"$1\" \"$2\""
pascal@18034 652 }
pascal@18034 653
pascal@18034 654 burniso()
pascal@18034 655 {
pascal@18034 656 wodim -v speed=$(fgrep "drive speed" /proc/sys/dev/cdrom/info | cut -f3) \
pascal@18034 657 -eject -multi "$ISO"
pascal@18034 658 }
pascal@18034 659
pascal@18034 660 blankcd()
pascal@18034 661 {
pascal@18034 662 wodim -v -blank=fast
pascal@18034 663 }
pascal@18034 664
pascal@18771 665 customsector()
pascal@18771 666 {
pascal@19324 667 echo $(get 32848 "/mnt/$ISO" 4)
pascal@18771 668 }
pascal@18771 669
pascal@18771 670 hascustomconf()
pascal@18771 671 {
pascal@18771 672 [ "$(ddq bs=2k skip=$(customsector) if="/mnt/$ISO" | ddq bs=1 count=6)" \
pascal@20891 673 = "#!boot" ]
pascal@18771 674 }
pascal@18771 675
pascal@18771 676 gotcustomconf()
pascal@18771 677 {
pascal@18774 678 hascustomconf && echo -en "\"$1\" \"$2\""
pascal@18771 679 }
pascal@18771 680
pascal@18771 681 getcustomconf()
pascal@18771 682 {
pascal@18774 683 cd ${1:-/mnt}
pascal@18774 684 ddq bs=2k skip=$(customsector) if="/mnt/$ISO" | while read line; do
pascal@18771 685 case "$line" in
pascal@18771 686 \#!boot*) ;;
pascal@18771 687 append=*) echo ${line#append=} > cmdline && ls -l cmdline ;;
pascal@18771 688 initrd:*) cnt=${line#initrd:}
pascal@18771 689 { ddq bs=512 count=$(($cnt / 512));
pascal@18771 690 ddq bs=1 count=$(($cnt % 512)); } > initrd &&
pascal@18771 691 ls -l initrd
pascal@18771 692 break ;;
pascal@20771 693 *) break ;;
pascal@18771 694 esac
pascal@18771 695 done
pascal@18771 696 cd - > /dev/null
pascal@18774 697 [ -z "$1" ] && echo -e "\rPress RETURN to continue." && read n
pascal@18771 698 }
pascal@18771 699
pascal@17492 700 gotisomd5()
pascal@17492 701 {
pascal@17562 702 [ "$(which md5sum 2> /dev/null)" ] &&
pascal@17635 703 [ $(get 0 /mnt/$ISO) -eq 23117 ] &&
pascal@17635 704 [ $(get 18 /mnt/$ISO) -ne 0 ] && echo -en "\"$1\" \"$2\""
pascal@17492 705 }
pascal@17492 706
pascal@17492 707 isomd5()
pascal@17492 708 {
pascal@17492 709 dotwait "Checking iso image"
pascal@17635 710 [ "$(ddq if=/mnt/$ISO bs=2k skip=16 \
pascal@20891 711 count=$(($(get 32848 /mnt/$ISO 4)-16)) | md5sum)" = \
pascal@17635 712 "$(ddq if=/mnt/$ISO bs=16 count=1 skip=2047 | od -N 16 -t x1 -An | \
pascal@17496 713 sed 's/ //g') -" ] && echo "OK" || echo "ERROR"
pascal@17635 714 echo -en "\rChecking iso hybrid boot..."
pascal@17635 715 n=$(($(get 2 /mnt/$ISO)-1+($(get 4 /mnt/$ISO)-1)*512))
pascal@17635 716 if [ $n -lt 40000 -a $n -gt 32768 ]; then
pascal@17635 717 s=$(get 0 /mnt/$ISO 2 $n | awk '{ i+= $0 } END { print i }')
pascal@17635 718 [ $(((1+$s+$(get $(($n+1)) /mnt/$ISO 1)) % 65536)) -eq 0 ] &&
pascal@17635 719 echo "OK" || echo "ERROR"
pascal@17635 720 fi
pascal@18771 721 if hascustomconf; then
pascal@18771 722 echo -en "\rChecking iso custom config..."
pascal@18771 723 TMP=/tmp/$(basename $0)$$md5
pascal@18771 724 md5="$(ddq bs=2k skip=$(customsector) if=/mnt/$ISO | while read line; do
pascal@18771 725 case "$line" in
pascal@18771 726 \#!boot*) echo ${line#*boot } > $TMP ;;
pascal@18771 727 append=*) echo $line ;;
pascal@18771 728 initrd:*) echo $line
pascal@18771 729 cnt=${line#initrd:}
pascal@18771 730 ddq bs=512 count=$((cnt / 512))
pascal@18771 731 ddq bs=1 count=$((cnt % 512))
pascal@18771 732 break ;;
pascal@20771 733 *) break ;;
pascal@18771 734 esac
pascal@18771 735 done | md5sum | cut -c1-32)"
pascal@20891 736 [ "$md5" = "$(cat $TMP)" ] && echo "OK" || echo "ERROR"
pascal@18771 737 rm -f $TMP
pascal@18771 738 fi
pascal@17492 739 rm -f /tmp/wait
pascal@17562 740 echo -e "\rPress RETURN to continue."
pascal@17496 741 read n
pascal@17492 742 }
pascal@17492 743
pascal@20891 744 if [ "$1" = "--build" ]; then #install-begin
pascal@20763 745 cp $0 $0.tmp
pascal@20763 746 uuencode -m - < ifmem.bin | sed -e 's|^[ \t]*||;s|[ \t]*###.*||' \
pascal@20771 747 -e 's| *;;|;;|;s|\t\t*|\t|g' \
pascal@20763 748 -e '/^ifmemcode$/r/dev/stdin' -e '/^ifmemcode$/d' -i $0.tmp
pascal@18771 749 uuencode -m - < bootloader.bin | sed -e '/^bootloader$/r/dev/stdin' \
pascal@20764 750 -e '/^bootloader$/d' -e '/install-begin$/,/install-end$/d' -i $0.tmp
pascal@20763 751 mv -f $0.tmp $0; exit
pascal@18771 752 fi #install-end
pascal@18771 753 parse_isolinux()
pascal@18771 754 {
pascal@18771 755 awk 'BEGIN { IGNORECASE=1 }
pascal@18771 756 function multi(n)
pascal@18771 757 {
pascal@18771 758 auto=$n
pascal@18771 759 for (--n; n < NF; n+=2) {
pascal@18771 760 s=$n
pascal@18771 761 if (s ~ /M$/) s = substr(s,0,length(s)-1)
pascal@18771 762 else s /= 1024
pascal@18771 763 sizes=int(s) " " sizes
pascal@18771 764 }
pascal@18771 765 next
pascal@18771 766 }
pascal@18771 767 {
pascal@18771 768 if ($1 == "LABEL") {
pascal@18771 769 label=$2
pascal@18771 770 if (auto == "") auto=label
pascal@18771 771 }
pascal@18771 772 if ($1 == "KERNEL" || $1 == "COM32") kernel[label]=$2
pascal@18771 773 if ($1 == "INITRD") initrd[label]=$2
pascal@18771 774 if ($1 == "APPEND") {
pascal@18771 775 i=2
pascal@18771 776 if (kernel[label] ~ "ifmem.c32") multi(3)
pascal@18771 777 if (kernel[label] ~ "c32box.c32") {
pascal@18771 778 if ($2 == "linux") { kernel[label]=$3; i=4 }
pascal@18771 779 if ($2 == "ifmem") multi(4)
pascal@18771 780 }
pascal@18771 781 if (kernel[label] ~ "ifcpu64.c32") { auto=$4; next }
pascal@18771 782 while (i <= NF) {
pascal@18771 783 if ($i ~ "^initrd=") initrd[label]=substr($i,8)
pascal@18771 784 else cmdline[label]=cmdline[label] " " $i
pascal@18771 785 i++
pascal@18771 786 }
pascal@18771 787 }
pascal@18771 788 }
pascal@18771 789 END {
pascal@18771 790 print "KERNEL=\"" kernel[auto] "\""
pascal@18771 791 print "INITRD=\"" initrd[auto] "\""
pascal@18771 792 print "CMDLINE=\"" substr(cmdline[auto],2) "\""
pascal@18771 793 print "SIZES=\"" sizes "\""
pascal@18771 794 }'
pascal@18771 795 }
pascal@18771 796
pascal@18771 797 locase()
pascal@18771 798 {
pascal@18771 799 echo "$1" | tr [A-Z] [a-z]
pascal@18771 800 }
pascal@18771 801
pascal@18771 802 ifmemcode()
pascal@18771 803 {
pascal@18771 804 uudecode <<EOT
pascal@18771 805 ifmemcode
pascal@18771 806 EOT
pascal@18771 807 }
pascal@18771 808
pascal@18771 809 floppyset()
pascal@18771 810 {
pascal@18771 811 gotcdfile isolinux.cfg
pascal@18771 812 parse_isolinux < $file > /tmp/var$$
pascal@18771 813 . /tmp/var$$
pascal@19877 814 for i in /media/cdrom/$KERNEL $(dirname $file)/$KERNEL /media/cdrom/$(locase $KERNEL) \
pascal@18771 815 $(dirname $file)/$(locase $KERNEL); do
pascal@18771 816 [ -s $i ] && KERNEL=$i && break
pascal@18771 817 done
pascal@20771 818 rm -f /tmp/var$$
pascal@18771 819 [ $(get 514 $KERNEL 4) -eq 1400005704 ] || return
pascal@18771 820 n=$(($(get 497 $KERNEL 1)+1))
pascal@18771 821 ddq bs=512 count=$n if=$KERNEL of=/tmp/fd$$
pascal@18771 822 uudecode <<EOT | ddq of=/tmp/fd$$ conv=notrunc
pascal@18771 823 bootloader
pascal@18771 824 EOT
pascal@18771 825 pos=$(($n*512))
pascal@18771 826 if [ -n "$CMDLINE" ]; then
pascal@18771 827 echo -n "$CMDLINE" | ddq bs=512 count=1 conv=sync >> /tmp/fd$$
pascal@18771 828 bytes2bin $n | ddq conv=notrunc \
pascal@18771 829 bs=1 seek=497 count=1 of=/tmp/fd$$
pascal@18771 830 words2bin $pos | ddq conv=notrunc \
pascal@18771 831 bs=1 seek=34 count=2 of=/tmp/fd$$
pascal@18771 832 [ $(get 518 $KERNEL 4) -ge 514 ] &&
pascal@18771 833 words2bin 32768 9 | ddq conv=notrunc \
pascal@18771 834 bs=1 seek=552 count=4 of=/tmp/fd$$
pascal@18771 835 fi
pascal@18771 836 syssize=$(echo $(get 500 /tmp/fd$$ 4))
pascal@18771 837 ddq bs=512 skip=$n if=$KERNEL | cat - /dev/zero | \
pascal@18771 838 ddq bs=512 count=$((($syssize+31)/32)) conv=sync >> /tmp/fd$$
pascal@18771 839 base=$(stat -c %s /tmp/fd$$)
pascal@18771 840 len=
pascal@18771 841 if [ "$INITRD" ]; then
pascal@18771 842 l=0
pascal@18771 843 for i in ${INITRD//,/ }; do
pascal@19877 844 for j in /media/cdrom/$i $(dirname $KERNEL)/$i /media/cdrom/$(locase $i) \
pascal@18771 845 $(dirname $KERNEL)/$(locase $i); do
pascal@18771 846 [ -s $j ] && i=$j && break
pascal@18771 847 done
pascal@18771 848 ddq if=$i >> /tmp/fd$$
pascal@18771 849 l=$(($l+$(stat -c %s $i)))
pascal@18771 850 r=$((4 - ($l % 4)))
pascal@18771 851 if [ $r -ne 4 ]; then
pascal@18771 852 ddq if=/dev/zero bs=1 count=$r >> /tmp/fd$$
pascal@18771 853 l=$(($l + $r))
pascal@18771 854 fi
pascal@18771 855 case "$i:$INITRD" in
pascal@20762 856 *rootfs.gz:*rootfs.gz,*) continue ### loram
pascal@18771 857 esac
pascal@18771 858 len="$len $l"; l=0
pascal@18771 859 done
pascal@18771 860 rdadrs=${RDADRS:-$(((($syssize*16)+0x1F0000) & -4096))}
pascal@18771 861 words2bin $(($rdadrs & 0xFFFF)) $(($rdadrs >> 16)) | ddq \
pascal@18771 862 conv=notrunc bs=1 seek=536 count=4 of=/tmp/fd$$
pascal@18771 863 fi
pascal@18771 864 n=$(echo $len | wc -w)
pascal@18771 865 if [ $((494 - $(get 494 /tmp/fd$$))) -ge $(($n * 4)) ]; then
pascal@18771 866 i=$(($(get 494 /tmp/fd$$)))
pascal@18771 867 bytes2bin $(($i + ($n*4) - 256)) | ddq bs=1 conv=notrunc \
pascal@18771 868 seek=496 count=1 of=/tmp/fd$$
pascal@18771 869 else
pascal@18771 870 i=$(($pos + 0x1FC - ($n*4)))
pascal@18771 871 bytes2bin $(($i % 256)) $((i / 256)) 252 | ddq bs=1 \
pascal@18771 872 conv=notrunc seek=494 count=3 of=/tmp/fd$$
pascal@18771 873 s=$(($i - 2*$(echo "$SIZES" | wc -w)))
pascal@18771 874 p=$(($s - $(ifmemcode | wc -c)))
pascal@18771 875 ifmemcode | ddq bs=1 conv=notrunc seek=$p of=/tmp/fd$$
pascal@18771 876 words2bin $SIZES | ddq bs=1 conv=notrunc seek=$s of=/tmp/fd$$
pascal@18771 877 bytes2bin 154 $(($p%256)) $(($p/256)) 0 144 | \
pascal@18771 878 ddq bs=1 conv=notrunc seek=60 of=/tmp/fd$$
pascal@18771 879 fi
pascal@18771 880 for r in $len ; do
pascal@18771 881 words2bin $(($r & 0xFFFF)) $(($r >> 16)) | ddq conv=notrunc \
pascal@18771 882 bs=1 seek=$i count=4 of=/tmp/fd$$
pascal@18771 883 i=$(($i + 4))
pascal@18771 884 done
pascal@18771 885 split -b 1440k /tmp/fd$$ fd$$
pascal@18771 886 rm -f /tmp/fd$$
pascal@18771 887 n=1; i=0; r=0
pascal@18771 888 set -- $len
pascal@18771 889 ls fd$$* | while read file ; do
pascal@18771 890 if [ $i -gt $(($1+$base)) ]; then
pascal@18771 891 shift
pascal@18771 892 r=$(($r+100)); n=0; i=0; base=0
pascal@18771 893 fi
pascal@18771 894 ddq of=$file bs=18k seek=80 count=0
pascal@18771 895 i=$(($i+1474560))
pascal@18771 896 printf "mv %s fd%03d.img\n" $file $(($r+$n))
pascal@18771 897 n=$(($n+1))
pascal@18771 898 done | sh
pascal@18771 899 ls fd???.img
pascal@19878 900 mv fd???.img /mnt
pascal@18771 901 }
pascal@18771 902
pascal@14257 903 fdbootstrap()
pascal@14257 904 {
pascal@18771 905 sz=$((512 * $(echo $(get 26 /mnt/$ISO 1))))
pascal@20771 906 $DIALOG --clear --title " Create a floppy bootstrap " \
pascal@14271 907 --yes-label "Continue" --yesno \
paul@14263 908 "\nThe floppy will install a driver to access the ISO file
pascal@20771 909 on your hard disk and will emulate a CD-ROM during the boot process.\n\n
pascal@20771 910 Please insert a floppy in drive now.\n" 10 70
pascal@14271 911 [ $? -eq 0 ] || return
pascal@17474 912 ddq if=/mnt/$ISO of=/tmp/bootiso bs=1 count=512 \
pascal@17810 913 skip=$(( $(get 64 /mnt/$ISO) - $sz ))
pascal@17474 914 echo "$ISO" | ddq of=/tmp/bootiso bs=512 seek=1 count=1
pascal@17474 915 ddq if=/mnt/$ISO of=/tmp/bootiso bs=1 count=$sz seek=2 \
pascal@17810 916 skip=$(( $(get 64 /mnt/$ISO) - $sz + 512 ))
pascal@17474 917 mkfloppy /tmp/bootiso
pascal@17474 918 rm -f /tmp/bootiso
pascal@14257 919 }
pascal@14257 920
pascal@14257 921 usbdev()
pascal@14257 922 {
pascal@17476 923 dotwait "Wait 5 seconds for USB devices"
pascal@14257 924 sleep 5
pascal@17476 925 rm -f /tmp/wait
pascal@14257 926 DEV="$(grep -l 1 /sys/block/*/removable | \
pascal@14257 927 sed 's|/sys/block/\(.*\)/removable|\1|')"
pascal@17491 928 grep -qs 1 /sys/block/$DEV/ro && return
pascal@17454 929 [ "$DEV" ] || return
pascal@17491 930 cat > /tmp/dialog <<EOT
pascal@20778 931 $DIALOG --clear --title " Select your USB key " \
pascal@14257 932 --menu "\nPlease select the USB key according to its known size.\n\n" \
pascal@14257 933 14 70 4 \
pascal@14257 934 $(for i in $DEV ; do
pascal@17491 935 echo -n "/dev/$i \"$(($(cat /sys/block/$i/size)/2048))MB $(cat /sys/block/$i/device/model 2> /dev/null)\" "
pascal@20762 936 done)
pascal@17491 937 EOT
pascal@17491 938 exec 3>&1
pascal@17491 939 device=$(. /tmp/dialog 2>&1 1>&3)
pascal@14257 940 retval=$?
pascal@14257 941 exec 3>&-
pascal@14257 942 [ $retval -eq 0 ]
pascal@14257 943 }
pascal@14257 944
pascal@17491 945 tazusbmsg()
pascal@17491 946 {
pascal@17491 947 [ "$(which tazusb 2> /dev/null)" ] || return
pascal@17491 948 echo "You should choose 'USB key read/write installation' to be
pascal@17491 949 able to save the package updates or your own configuration and data files.\n\n"
pascal@17491 950 }
pascal@17491 951
pascal@14257 952 usbbootkey()
pascal@14257 953 {
pascal@20771 954 $DIALOG --clear --title " Create a USB boot key " \
pascal@14257 955 --yes-label "Continue" --yesno \
pascal@14257 956 "\nThe USB key will be used like a CD-ROM. You will not be able to write
pascal@17454 957 any data on the boot partition.\n\n
pascal@17454 958 An extra FAT32 partition will be created with the remaining free space.\n\n
pascal@20771 959 $(tazusbmsg)Please plug your USB stick in now.\n" 16 70
pascal@14257 960 [ $? -eq 0 ] || return
pascal@14257 961 usbdev || return
pascal@17454 962
pascal@20762 963 ### perform dd in progress bar
pascal@17491 964 max=$(($(cat /sys/block/loop0/size)/2048))
pascal@20771 965 i=0; ddq if=/mnt/$ISO bs=1024k | (
pascal@20771 966 while ddq bs=1024k count=1 ; do
pascal@17454 967 i=$(($i + 1))
pascal@17454 968 [ $i -gt $max ] && break
pascal@17455 969 echo $((($i*100)/$max)) | dialog --gauge \
pascal@17455 970 " The ISO image transfer can be long. Please wait..." \
pascal@17476 971 6 70 0 > /dev/tty0 2>&1
pascal@17454 972 done ) > $device
pascal@17454 973
pascal@20762 974 ### partition + fat32 format for the remaining space
pascal@17860 975 for p in 0 16; do
pascal@17860 976 get $((450+$p)) $device 2 12 | xargs echo | {
pascal@17860 977 read dx cx ol oh ll lh
pascal@17860 978 [ $dx -eq $((0x3F17)) ] || continue
pascal@17454 979 cx=$(($cx & 0xFF00))
pascal@17454 980 ofs=$(($ll+($lh<<16)))
pascal@17454 981 n=$(($(cat /sys/block/${device#/dev/}/size)-$ofs))
pascal@17454 982 m=$(($cx+($n/8)))
pascal@17454 983 [ $m -gt $((0x3FF00)) ] && m=$((0x3FF00))
pascal@17454 984 m=$((($m & 0xFF00)+(($m>>16)<<6)))
pascal@17454 985 words2bin 0 $((0x101+$cx)) 0x3F0B $((32+$m)) \
pascal@17454 986 $ll $lh $(($n & 0xFFFF)) $(($n >> 16)) | \
pascal@17860 987 ddq bs=1 seek=$((462-$p)) of=$device
pascal@17454 988 if [ "$(which mkdosfs 2> /dev/null)" ]; then
pascal@17562 989 losetup -o $((512*$ofs)) /dev/loop2 $device
pascal@17562 990 mkdosfs -n "SLITAZ BOOT" /dev/loop2
pascal@17454 991 words2bin $(($ofs & 0xFFFF)) $(($ofs >> 16)) | \
pascal@17562 992 ddq bs=1 seek=28 of=/dev/loop2
pascal@17860 993 sync
pascal@17562 994 losetup -d /dev/loop2
pascal@17454 995 fi
pascal@17860 996 }
pascal@17860 997 done
pascal@14257 998 }
pascal@14257 999
pascal@13697 1000 usbkey()
pascal@13697 1001 {
pascal@20771 1002 $DIALOG --clear --title " Create a SliTaz USB key " \
pascal@13697 1003 --yes-label "Continue" --yesno \
pascal@13697 1004 "\nUnlike a hard drive install, the filesystem is kept in a compressed
pascal@13697 1005 rootfs.gz. The filesystem is loaded entirely into memory upon boot.
pascal@13697 1006 This should increase responsiveness, protect the filesystem against
pascal@13697 1007 accidental corruption and reduce read/writes to the USB drive.
pascal@13697 1008 Once setup, the tazusb utility can rewrite the root filesystem
pascal@20771 1009 with any changes you have made since booting up,
pascal@13697 1010 giving the effective benefits of a hard drive install.\n\n
pascal@13697 1011 /home is mounted on boot using the UUID of your particular flash drive.
pascal@13697 1012 Unlike a device name, the UUID has the benefit of never changing from machine
pascal@13697 1013 to machine.\n\n
pascal@20771 1014 Please plug your USB stick in now.\n" 19 70
pascal@14271 1015 [ $? -eq 0 ] || return
pascal@14257 1016 usbdev || return
pascal@13697 1017 exec 3>&1
pascal@20778 1018 format=`$DIALOG --clear --title " Select the filesystem " \
pascal@13733 1019 --radiolist "\nPlease select the filesystem type to create.\n\n\
paul@13698 1020 The filesystem creation will erase all the data \
pascal@13699 1021 in the USB key." 14 70 4 \
pascal@13733 1022 "none" "Do not erase the USB key" on \
pascal@13733 1023 "ext3" "Ext3 journaling filesystem" off \
pascal@13733 1024 "ext2" "Ext2 filesystem" off \
pascal@13733 1025 "fat32" "Windows FAT32 filesystem" off \
pascal@13697 1026 2>&1 1>&3`
pascal@13697 1027 retval=$?
pascal@13697 1028 exec 3>&-
pascal@14257 1029 [ $retval -eq 0 ] || return
pascal@13697 1030 [ "$format" != "none" ] && tazusb format $device "SliTaz" $format
pascal@13697 1031 tazusb gen-iso2usb /mnt/$ISO $device
pascal@13697 1032 }
pascal@13697 1033
pascal@13713 1034 mount_loram()
pascal@13713 1035 {
pascal@13713 1036 is_loram || return
pascal@21459 1037 insmod /lib/modules/squashfs.ko* 2> /dev/null
pascal@13713 1038 if [ -d /media/cdrom/fs ]; then
pascal@13713 1039 ln -s /media/cdrom/fs /sqfs
pascal@13713 1040 else
pascal@13713 1041 mkdir /sqfs
pascal@13713 1042 mount -o loop,ro -t squashfs /rootfs*.gz /sqfs
pascal@13713 1043 fi
pascal@21506 1044 cp -a /sqfs/dev/fuse /sqfs/dev/tty[12] /sqfs/dev/[hs]d* /dev
pascal@13713 1045 ln -s /sqfs/lib/* lib
pascal@21386 1046 ln -fs /sqfs/usr /sqfs/var /
pascal@21467 1047 mkdir /etc && cp /sqfs/etc/dialogrc /etc 2> /dev/null
pascal@13713 1048 }
pascal@13713 1049
pascal@13713 1050 umount_loram()
pascal@13713 1051 {
pascal@13713 1052 is_loram || return
pascal@20778 1053 rm /var /usr
pascal@13713 1054 umount -d /sqfs
pascal@21377 1055 rmdir /sqfs 2> /dev/null || rm -f /sqfs
pascal@13713 1056 }
pascal@13713 1057
pascal@17569 1058 dosync()
pascal@13691 1059 {
pascal@17569 1060 sync
pascal@13713 1061 umount_loram
pascal@13691 1062 umount -d /media/cdrom
pascal@16073 1063 rm -f /dev/cdrom
pascal@13691 1064 umount /mnt
pascal@16041 1065 umount_proc
pascal@17569 1066 }
pascal@17569 1067
pascal@17569 1068 text()
pascal@17569 1069 {
pascal@18774 1070 init=
pascal@18774 1071 cmdline="$(cat /proc/cmdline)"
pascal@18774 1072 if hascustomconf; then
pascal@18774 1073 getcustomconf /tmp > /dev/null
pascal@18774 1074 [ -s /tmp/cmdline ] &&
pascal@18774 1075 cmdline="$cmdline $(cat /tmp/cmdline)" &&
pascal@18774 1076 init="$(sed '/rdinit=/!d;s/.*rdinit=\([^ ]*\).*/\1/' < /tmp/cmdline)"
pascal@18774 1077 [ -s /tmp/initrd ] && uncpio /tmp/initrd
pascal@18774 1078 fi
pascal@17569 1079 dosync
pascal@18774 1080 exec ${init:-/init} $cmdline
pascal@13691 1081 }
pascal@13691 1082
pascal@13691 1083 live()
pascal@13691 1084 {
pascal@13691 1085 n=0
pascal@17476 1086 dotwait "Extract filesystem..."
pascal@17562 1087 for i in $(ls_r /media/cdrom/boot/rootfs*gz); do
pascal@17562 1088 grep -q ' lm ' /proc/cpuinfo && [ -s ${i}64 ] && i=${i}64
pascal@13691 1089 [ $((n++)) -eq 0 ] || uncpio $i
pascal@13691 1090 done
pascal@17476 1091 rm -f /tmp/wait
pascal@13691 1092 text
pascal@13691 1093 }
pascal@13691 1094
pascal@13713 1095 restart()
pascal@13691 1096 {
pascal@17476 1097 dosync
pascal@13713 1098 reboot -f
pascal@13691 1099 }
pascal@13691 1100
pascal@13713 1101 stop()
pascal@13691 1102 {
pascal@17476 1103 dosync
pascal@13713 1104 poweroff -f
pascal@13691 1105 }
pascal@13691 1106
pascal@17489 1107 dokexec()
pascal@17476 1108 {
pascal@17659 1109 kexec -l $file || return
pascal@17476 1110 dosync
pascal@17476 1111 kexec -e
pascal@17476 1112 }
pascal@17476 1113
pascal@17489 1114 runmemtest()
pascal@17489 1115 {
pascal@17635 1116 gotcdfile "memtest*" && dokexec
pascal@17489 1117 }
pascal@17489 1118
pascal@17476 1119 runpxe()
pascal@17476 1120 {
pascal@20762 1121 gotcdfile "?pxe*" && dokexec
pascal@17476 1122 }
pascal@17476 1123
pascal@17931 1124 flavdata()
pascal@17931 1125 {
pascal@20762 1126 [ $(get 1024 /mnt/$ISO) -eq 35615 ] && n=2 ||
pascal@20762 1127 n=$((1+$(get 417 /mnt/$ISO 1)))
pascal@20762 1128 [ $n -eq 4 ] && n=20
pascal@20762 1129 [ $(get $(($n*512)) /mnt/$ISO) -eq 35615 ] || n=13
pascal@20762 1130 ddq if=/mnt/$ISO bs=512 skip=$n count=20 | zcat 2>/dev/null
pascal@17931 1131 }
pascal@17931 1132
pascal@17931 1133 hasflavinfo()
pascal@17931 1134 {
pascal@20891 1135 [ "$(flavdata | ddq bs=1 count=7)" = "0707010" ] &&
pascal@19510 1136 echo -en "\"$1\" \"$2\""
pascal@17931 1137 }
pascal@17931 1138
pascal@17931 1139 showfavinfo()
pascal@17931 1140 {
pascal@17931 1141 mkdir -p /tmp/data
pascal@17931 1142 flavdata | ( cd /tmp/data ; cpio -i )
pascal@17931 1143 file=/tmp/data/info
pascal@17931 1144 cat /tmp/data/*desc > $file
pascal@17931 1145 for i in /tmp/data/*list* ; do
pascal@17931 1146 echo "=== extra ${i#*list} files"
pascal@17931 1147 cat $i
pascal@17931 1148 done >> $file
pascal@20771 1149 $DIALOG --clear --title " Flavor info " --textbox $file 24 78
pascal@17931 1150 rm -rf /tmp/data
pascal@17931 1151 }
pascal@17931 1152
pascal@18771 1153 flavor()
pascal@18771 1154 {
pascal@18771 1155 cd /mnt
pascal@18771 1156 name="$(flavdata | cpio -t 2> /dev/null | sed 's/.[a-z]*$//;q')"
pascal@18771 1157 echo "Create ${name:=flavor}.flavor..."
pascal@18771 1158 tazlito iso2flavor "/mnt/$ISO" $name
pascal@18771 1159 ls -l $name.flavor 2> /dev/null || sleep 5
pascal@18771 1160 cd - > /dev/null
pascal@18771 1161 }
pascal@18771 1162
pascal@13697 1163 shell()
pascal@13697 1164 {
pascal@20771 1165 trap text 2
pascal@21459 1166 getty -n -l /bin/ash 38400 tty1 2> /dev/null || sh
pascal@13697 1167 }
pascal@13697 1168
pascal@14247 1169 BIN=bin/mount.posixovl
pascal@14247 1170 [ -x /usr/s$BIN ] || mv /bin/mount.posixovl.iso2exe \
pascal@17489 1171 /usr/s$BIN 2> /dev/null || mv /bin/mount.posixovl.iso2exe /$BIN 2> /dev/null
pascal@16041 1172 mount_proc
pascal@18804 1173 for i in /sys/block/*/dev /sys/block/*/*/dev ; do
pascal@18804 1174 [ -s "$i" ] || continue
pascal@18804 1175 n=${i%/dev}
pascal@18804 1176 n=/dev/${n##*/}
pascal@18804 1177 [ -e $n ] && continue
pascal@18804 1178 mknod $n b $(sed 's/:/ /' < $i)
pascal@18804 1179 done
pascal@17489 1180 ISO="$(getarg bootfrom | sed 's/.://;s|\\|/|g')"
pascal@19510 1181 getiso || text 2> /dev/null
pascal@13713 1182 mount_loram
pascal@16041 1183 case "${ISO##*/}$(getarg mode)" in
pascal@16047 1184 *install*|*INSTALL*) install ;;
pascal@16047 1185 *live*|*LIVE*) live ;;
pascal@16047 1186 *text*|*TEXT*) text ;;
pascal@13691 1187 esac
pascal@17489 1188 which $DIALOG 2> /dev/null || DIALOG=tinydialog
pascal@13713 1189 dmesg > /tmp/dmesg
pascal@13691 1190
pascal@18778 1191 isotitle="$(blkid /mnt/$ISO | sed 's/.*LABEL="\([^"]*\).*/\1/') $(stat \
pascal@18778 1192 -c %y /media/cdrom | sed 's/ .*//') $(basename $ISO)"
pascal@13691 1193 while true; do
pascal@20771 1194 trap shell 2
pascal@16055 1195 keymap="$(cat /etc/keymap.conf 2> /dev/null)"
pascal@16055 1196 locale="$(sed '/^LANG=/!d;s/.*=//' /etc/locale.conf 2> /dev/null)"
pascal@14271 1197 cat > /tmp/dialog <<EOT
pascal@20778 1198 $DIALOG --clear --title " ${isotitle:-Welcome to Linux} " \
pascal@17454 1199 --menu "" 23 70 17 \
pascal@17489 1200 $(xfile tazkeymap "tazkeymap" "Select keyboard (${keymap:-none})") \
pascal@17489 1201 $(xfile tazlocale "tazlocale" "Select locale (${locale:-none})") \
pascal@17489 1202 $(cdfile boot/bzImage "live" "Linux RAM boot (full desktop)") \
pascal@17489 1203 "text" "Linux RAM boot" \
pascal@17635 1204 $(cdfile "README*" "readme" "Show the README file") \
pascal@18771 1205 $(gotcustomconf "getcustomconf" "Get custom config") \
pascal@17492 1206 $(gotisomd5 "isomd5" "Check the ISO image") \
pascal@17635 1207 $(cdfile "md5sum*" "md5" "Check the ISO files") \
pascal@17635 1208 $(cdfile "sha*sum*" "sha" "Check the ISO files") \
pascal@18034 1209 $(burnable "burniso" "Burn the ISO image") \
pascal@18034 1210 $(blankable "blankcd" "Blank the CD/DVD") \
pascal@16041 1211 $(gotposixovl "install" "Hard disk installation (UMSDOS way)") \
pascal@16041 1212 $(gotposixovl "installtaz" "Hard disk installation (TAZUSB way)") \
pascal@14271 1213 $(xfile tazusb "usbkey" "USB key read/write installation") \
pascal@17491 1214 $(ishybrid "usbbootkey" "USB boot key (read only)") \
paul@17935 1215 $(hasflavinfo "showfavinfo" "Show flavor extra info") \
pascal@18771 1216 $(xfile tazlito "flavor" "Get flavor file") \
pascal@17476 1217 $(fddata "fdbootstrap" "Create a floppy bootstrap") \
pascal@18771 1218 $(cdfile isolinux.cfg "floppyset" "Boot floppy set") \
pascal@17491 1219 "tazboot" "Get tazboot.exe Linux loader" \
pascal@17476 1220 $(cdexe boot/bzImage "bzimage" "Get linux DOS/EXE file") \
pascal@17635 1221 $(cdexe "memtest*" "memtest" "Get Memtest86 DOS/EXE file") \
pascal@17635 1222 $(cdfilef "memtest*" "fdmemtest" "Create a Memtest86 boot floppy") \
pascal@18771 1223 $(:||cdfilex "memtest*" "runmemtest" "Start Memtest86") \
pascal@20762 1224 $(cdexe "?pxe*" "pxe" "Get SliTaz Web boot DOS/EXE utility") \
pascal@20762 1225 $(cdfilef "?pxe*" "fdpxe" "Create a SliTaz Web boot floppy") \
pascal@20762 1226 $(:||cdfilex "?pxe*" "runpxe" "Start the SliTaz Web boot utility") \
pascal@14271 1227 $(xfile reboot "restart" "Restart the computer") \
pascal@14271 1228 $(xfile poweroff "stop" "Power off") \
pascal@13697 1229 "bootlog" "Linux boot messages" \
pascal@20762 1230 "shell" "Shell prompt"
pascal@14271 1231 EOT
pascal@14271 1232 exec 3>&1
pascal@17489 1233 value=$(. /tmp/dialog 2>&1 1>&3)
pascal@13691 1234 retval=$?
pascal@13691 1235 exec 3>&-
pascal@13691 1236 [ $retval -eq 0 ] || continue
pascal@13691 1237 $value
pascal@13691 1238 done